Attribute VB_Name = "MediaInfoDLL"
Option Explicit

' Include this module in your Visual Basic project for access to MediaInfo.dll and
' keep two things in mind concerning strings for Unicode ability:
'
' 1. All strings (constants and variables) passed to MediaInfo must be passed with StrPtr().
' 2. All strings returned by MediaInfo must be converted with bstr() to a Visual Basic String.
'
' This module is tested and will work with Visual Basic 5 and 6 on Windows 98SE and 2000
' (at least).
'
' Use at own risk, under the same license as MediaInfo itself.
'
' Ingo Brckl, June 2005

Public Enum stream_t_C
  Stream_General
  Stream_Video
  Stream_Audio
  Stream_Text
  Stream_Chapters
  Stream_Image
  Stream_Max
End Enum

Public Enum info_t_C
  Info_Name
  Info_Text
  Info_Measure
  Info_Options
  Info_Name_Text
  Info_Measure_Text
  Info_Info
  Info_HowTo
  Info_Max
End Enum

Public Enum infooptions_t_C
  InfoOption_ShowInInform
  InfoOption_Support
  InfoOption_ShowInSupported
  InfoOption_TypeOfValue
  InfoOption_Max
End Enum

Public Enum informoptions_t_C
  InformOption_Nothing
  InformOption_Custom
  InformOption_HTML
  InformOption_Max
End Enum

Public Declare Sub MediaInfo_Close Lib "MediaInfo.dll" (ByVal Handle As Long)
Public Declare Function MediaInfo_Count_Get Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal StreamKind As stream_t_C, ByVal StreamNumber As Long) As Long
Public Declare Function MediaInfo_Get Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal StreamKind As stream_t_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal InfoKind As info_t_C, ByVal SearchKind As info_t_C) As Long
Public Declare Function MediaInfo_GetI Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal StreamKind As stream_t_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal InfoKind As info_t_C) As Long
Public Declare Function MediaInfo_Inform Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal Options As informoptions_t_C) As Long
Public Declare Function MediaInfo_Open Lib "MediaInfo.dll" (ByVal File As Long) As Long
Public Declare Function MediaInfo_Open_Buffer Lib "MediaInfo.dll" (Begin As Any, ByVal Begin_Size As Long, End_ As Any, ByVal End_Size As Long) As Long
Public Declare Function MediaInfo_Option Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal Option_ As Long, ByVal Value As Long) As Long
Public Declare Function MediaInfo_Save Lib "MediaInfo.dll" (ByVal Handle As Long) As Long
Public Declare Function MediaInfo_Set Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal ToSet As Long, ByVal StreamKind As stream_t_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal OldParameter As Long) As Long
Public Declare Function MediaInfo_SetI Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal ToSet As Long, ByVal StreamKind As stream_t_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal OldParameter As Long) As Long
Public Declare Function MediaInfo_State_Get Lib "MediaInfo.dll" (ByVal Handle As Long) As Long

Private Declare Function lstrlenW Lib "kernel32" (ByVal pStr As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (pDst As Any, pSrc As Any, ByVal bLen As Long)

Public Function bstr(ptr As Long) As String
' convert a C wchar* to a Visual Basic string

  Dim l As Long

  l = lstrlenW(ptr)
  bstr = String$(l, vbNullChar)

  RtlMoveMemory ByVal StrPtr(bstr), ByVal ptr, l * 2

End Function
